 ; Calculation of a factorial value using a simple loop

  ; set up the exception addresses
  THUMB
  AREA RESET, CODE, READONLY
  EXPORT  __Vectors
  EXPORT Reset_Handler
__Vectors 
  DCD 0x00180000     ; top of the stack 
  DCD Reset_Handler  ; reset vector - where the program starts

  AREA Task2b_Code, CODE, READONLY
Reset_Handler
  ENTRY
start	
  MOV r1,#1    ; count the number of multiplications performed 
  MOV r2,#6    ; the final value in the factorial calculation
  MOV r3,#1    ; the factorial result will be stored here

  ; loop r2 times forming the product  
fact
  MUL r3,r1,r3  ; form the next product - note that MUL r3,r3,r2 gives unpredictable output
  ADDS r1,r1,#1 ; find the next multiplicand
  CMP r1,r2     ; check if the final value has been reached
  BMI fact      ; continue if all products have not been formed
    
exit    ; stay in an endless loop 
  B exit
  END

